import { hasInjectionContext as ce, inject as ie, getCurrentInstance as ae, ref as G, watch as ue, reactive as fe, markRaw as x, effectScope as le, isRef as w, isReactive as H, toRef as A, toRaw as de, nextTick as M, computed as K, getCurrentScope as pe, onScopeDispose as he, toRefs as q, defineComponent as me, openBlock as _e, createElementBlock as Ee, Fragment as ge, createTextVNode as be, toDisplayString as Q, unref as ve, createElementVNode as ye, defineCustomElement as Ne } from "vue";
var Oe = !1;
function C(e, c, s) {
  return Array.isArray(e) ? (e.length = Math.max(e.length, c), e.splice(c, 1, s), s) : (e[c] = s, s);
}
function L(e, c) {
  if (Array.isArray(e)) {
    e.splice(c, 1);
    return;
  }
  delete e[c];
}
/*!
 * pinia v2.1.7
 * (c) 2023 Eduardo San Martin Morote
 * @license MIT
 */
let j;
const $ = (e) => j = e, Ve = process.env.NODE_ENV !== "production" ? Symbol("pinia") : (
  /* istanbul ignore next */
  Symbol()
);
function N(e) {
  return e && typeof e == "object" && Object.prototype.toString.call(e) === "[object Object]" && typeof e.toJSON != "function";
}
var S;
(function(e) {
  e.direct = "direct", e.patchObject = "patch object", e.patchFunction = "patch function";
})(S || (S = {}));
const W = typeof window < "u", R = (process.env.NODE_ENV !== "production" || !1) && process.env.NODE_ENV !== "test" && W;
function ee(e, c) {
  for (const s in c) {
    const o = c[s];
    if (!(s in e))
      continue;
    const i = e[s];
    N(i) && N(o) && !w(o) && !H(o) ? e[s] = ee(i, o) : e[s] = o;
  }
  return e;
}
const te = () => {
};
function X(e, c, s, o = te) {
  e.push(c);
  const i = () => {
    const f = e.indexOf(c);
    f > -1 && (e.splice(f, 1), o());
  };
  return !s && pe() && he(i), i;
}
function V(e, ...c) {
  e.slice().forEach((s) => {
    s(...c);
  });
}
const Pe = (e) => e();
function U(e, c) {
  e instanceof Map && c instanceof Map && c.forEach((s, o) => e.set(o, s)), e instanceof Set && c instanceof Set && c.forEach(e.add, e);
  for (const s in c) {
    if (!c.hasOwnProperty(s))
      continue;
    const o = c[s], i = e[s];
    N(i) && N(o) && e.hasOwnProperty(s) && !w(o) && !H(o) ? e[s] = U(i, o) : e[s] = o;
  }
  return e;
}
const De = process.env.NODE_ENV !== "production" ? Symbol("pinia:skipHydration") : (
  /* istanbul ignore next */
  Symbol()
);
function xe(e) {
  return !N(e) || !e.hasOwnProperty(De);
}
const { assign: b } = Object;
function Y(e) {
  return !!(w(e) && e.effect);
}
function Z(e, c, s, o) {
  const { state: i, actions: f, getters: p } = c, u = s.state.value[e];
  let v;
  function m() {
    !u && (process.env.NODE_ENV === "production" || !o) && (s.state.value[e] = i ? i() : {});
    const _ = process.env.NODE_ENV !== "production" && o ? (
      // use ref() to unwrap refs inside state TODO: check if this is still necessary
      q(G(i ? i() : {}).value)
    ) : q(s.state.value[e]);
    return b(_, f, Object.keys(p || {}).reduce((l, d) => (process.env.NODE_ENV !== "production" && d in _ && console.warn(`[🍍]: A getter cannot have the same name as another state property. Rename one of them. Found with "${d}" in store "${e}".`), l[d] = x(K(() => {
      $(s);
      const E = s._s.get(e);
      return p[d].call(E, E);
    })), l), {}));
  }
  return v = F(e, m, c, s, o, !0), v;
}
function F(e, c, s = {}, o, i, f) {
  let p;
  const u = b({ actions: {} }, s);
  if (process.env.NODE_ENV !== "production" && !o._e.active)
    throw new Error("Pinia destroyed");
  const v = {
    deep: !0
    // flush: 'post',
  };
  process.env.NODE_ENV !== "production" && !Oe && (v.onTrigger = (n) => {
    m ? E = n : m == !1 && !r._hotUpdating && (Array.isArray(E) ? E.push(n) : console.error("🍍 debuggerEvents should be an array. This is most likely an internal Pinia bug."));
  });
  let m, _, l = [], d = [], E;
  const O = o.state.value[e];
  !f && !O && (process.env.NODE_ENV === "production" || !i) && (o.state.value[e] = {});
  const I = G({});
  let z;
  function B(n) {
    let t;
    m = _ = !1, process.env.NODE_ENV !== "production" && (E = []), typeof n == "function" ? (n(o.state.value[e]), t = {
      type: S.patchFunction,
      storeId: e,
      events: E
    }) : (U(o.state.value[e], n), t = {
      type: S.patchObject,
      payload: n,
      storeId: e,
      events: E
    });
    const a = z = Symbol();
    M().then(() => {
      z === a && (m = !0);
    }), _ = !0, V(l, t, o.state.value[e]);
  }
  const oe = f ? function() {
    const { state: t } = s, a = t ? t() : {};
    this.$patch((h) => {
      b(h, a);
    });
  } : (
    /* istanbul ignore next */
    process.env.NODE_ENV !== "production" ? () => {
      throw new Error(`🍍: Store "${e}" is built using the setup syntax and does not implement $reset().`);
    } : te
  );
  function ne() {
    p.stop(), l = [], d = [], o._s.delete(e);
  }
  function T(n, t) {
    return function() {
      $(o);
      const a = Array.from(arguments), h = [], P = [];
      function se(g) {
        h.push(g);
      }
      function re(g) {
        P.push(g);
      }
      V(d, {
        args: a,
        name: n,
        store: r,
        after: se,
        onError: re
      });
      let D;
      try {
        D = t.apply(this && this.$id === e ? this : r, a);
      } catch (g) {
        throw V(P, g), g;
      }
      return D instanceof Promise ? D.then((g) => (V(h, g), g)).catch((g) => (V(P, g), Promise.reject(g))) : (V(h, D), D);
    };
  }
  const k = /* @__PURE__ */ x({
    actions: {},
    getters: {},
    state: [],
    hotState: I
  }), J = {
    _p: o,
    // _s: scope,
    $id: e,
    $onAction: X.bind(null, d),
    $patch: B,
    $reset: oe,
    $subscribe(n, t = {}) {
      const a = X(l, n, t.detached, () => h()), h = p.run(() => ue(() => o.state.value[e], (P) => {
        (t.flush === "sync" ? _ : m) && n({
          storeId: e,
          type: S.direct,
          events: E
        }, P);
      }, b({}, v, t)));
      return a;
    },
    $dispose: ne
  }, r = fe(process.env.NODE_ENV !== "production" || R ? b(
    {
      _hmrPayload: k,
      _customProperties: x(/* @__PURE__ */ new Set())
      // devtools custom properties
    },
    J
    // must be added later
    // setupStore
  ) : J);
  o._s.set(e, r);
  const y = (o._a && o._a.runWithContext || Pe)(() => o._e.run(() => (p = le()).run(c)));
  for (const n in y) {
    const t = y[n];
    if (w(t) && !Y(t) || H(t))
      process.env.NODE_ENV !== "production" && i ? C(I.value, n, A(y, n)) : f || (O && xe(t) && (w(t) ? t.value = O[n] : U(t, O[n])), o.state.value[e][n] = t), process.env.NODE_ENV !== "production" && k.state.push(n);
    else if (typeof t == "function") {
      const a = process.env.NODE_ENV !== "production" && i ? t : T(n, t);
      y[n] = a, process.env.NODE_ENV !== "production" && (k.actions[n] = t), u.actions[n] = t;
    } else
      process.env.NODE_ENV !== "production" && Y(t) && (k.getters[n] = f ? (
        // @ts-expect-error
        s.getters[n]
      ) : t, W && (y._getters || // @ts-expect-error: same
      (y._getters = x([]))).push(n));
  }
  if (b(r, y), b(de(r), y), Object.defineProperty(r, "$state", {
    get: () => process.env.NODE_ENV !== "production" && i ? I.value : o.state.value[e],
    set: (n) => {
      if (process.env.NODE_ENV !== "production" && i)
        throw new Error("cannot set hotState");
      B((t) => {
        b(t, n);
      });
    }
  }), process.env.NODE_ENV !== "production" && (r._hotUpdate = x((n) => {
    r._hotUpdating = !0, n._hmrPayload.state.forEach((t) => {
      if (t in r.$state) {
        const a = n.$state[t], h = r.$state[t];
        typeof a == "object" && N(a) && N(h) ? ee(a, h) : n.$state[t] = h;
      }
      C(r, t, A(n.$state, t));
    }), Object.keys(r.$state).forEach((t) => {
      t in n.$state || L(r, t);
    }), m = !1, _ = !1, o.state.value[e] = A(n._hmrPayload, "hotState"), _ = !0, M().then(() => {
      m = !0;
    });
    for (const t in n._hmrPayload.actions) {
      const a = n[t];
      C(r, t, T(t, a));
    }
    for (const t in n._hmrPayload.getters) {
      const a = n._hmrPayload.getters[t], h = f ? (
        // special handling of options api
        K(() => ($(o), a.call(r, r)))
      ) : a;
      C(r, t, h);
    }
    Object.keys(r._hmrPayload.getters).forEach((t) => {
      t in n._hmrPayload.getters || L(r, t);
    }), Object.keys(r._hmrPayload.actions).forEach((t) => {
      t in n._hmrPayload.actions || L(r, t);
    }), r._hmrPayload = n._hmrPayload, r._getters = n._getters, r._hotUpdating = !1;
  })), R) {
    const n = {
      writable: !0,
      configurable: !0,
      // avoid warning on devtools trying to display this property
      enumerable: !1
    };
    ["_p", "_hmrPayload", "_getters", "_customProperties"].forEach((t) => {
      Object.defineProperty(r, t, b({ value: r[t] }, n));
    });
  }
  return o._p.forEach((n) => {
    if (R) {
      const t = p.run(() => n({
        store: r,
        app: o._a,
        pinia: o,
        options: u
      }));
      Object.keys(t || {}).forEach((a) => r._customProperties.add(a)), b(r, t);
    } else
      b(r, p.run(() => n({
        store: r,
        app: o._a,
        pinia: o,
        options: u
      })));
  }), process.env.NODE_ENV !== "production" && r.$state && typeof r.$state == "object" && typeof r.$state.constructor == "function" && !r.$state.constructor.toString().includes("[native code]") && console.warn(`[🍍]: The "state" must be a plain object. It cannot be
	state: () => new MyClass()
Found in store "${r.$id}".`), O && f && s.hydrate && s.hydrate(r.$state, O), m = !0, _ = !0, r;
}
function je(e, c, s) {
  let o, i;
  const f = typeof c == "function";
  if (typeof e == "string")
    o = e, i = f ? s : c;
  else if (i = e, o = e.id, process.env.NODE_ENV !== "production" && typeof o != "string")
    throw new Error('[🍍]: "defineStore()" must be passed a store id as its first argument.');
  function p(u, v) {
    const m = ce();
    if (u = // in test mode, ignore the argument provided as we can always retrieve a
    // pinia instance with getActivePinia()
    (process.env.NODE_ENV === "test" && j && j._testing ? null : u) || (m ? ie(Ve, null) : null), u && $(u), process.env.NODE_ENV !== "production" && !j)
      throw new Error(`[🍍]: "getActivePinia()" was called but there was no active Pinia. Are you trying to use a store before calling "app.use(pinia)"?
See https://pinia.vuejs.org/core-concepts/outside-component-usage.html for help.
This will fail in production.`);
    u = j, u._s.has(o) || (f ? F(o, c, i, u) : Z(o, i, u), process.env.NODE_ENV !== "production" && (p._pinia = u));
    const _ = u._s.get(o);
    if (process.env.NODE_ENV !== "production" && v) {
      const l = "__hot:" + o, d = f ? F(l, c, i, u, !0) : Z(l, b({}, i), u, !0);
      v._hotUpdate(d), delete u.state.value[l], u._s.delete(l);
    }
    if (process.env.NODE_ENV !== "production" && W) {
      const l = ae();
      if (l && l.proxy && // avoid adding stores that are just built for hot module replacement
      !v) {
        const d = l.proxy, E = "_pStores" in d ? d._pStores : d._pStores = {};
        E[o] = _;
      }
    }
    return _;
  }
  return p.$id = o, p;
}
const Se = je("user", () => ({ name: "carla" })), we = /* @__PURE__ */ me({
  __name: "App.ce",
  props: ["foo"],
  emits: ["clicked"],
  setup(e, { emit: c }) {
    const s = c, o = Se();
    function i() {
      console.log("clicked from vue component"), s("clicked", { name: "carla" });
    }
    return (f, p) => (_e(), Ee(ge, null, [
      be(" Hello " + Q(ve(o).name) + " ", 1),
      ye("button", { onClick: i }, Q(e.foo || "foo is null"), 1)
    ], 64));
  }
}), ke = ".logo{height:6em;padding:1.5em;will-change:filter;transition:filter .3s}.logo:hover{filter:drop-shadow(0 0 2em #646cffaa)}.logo.vue:hover{filter:drop-shadow(0 0 2em #42b883aa)}:root{font-family:Inter,system-ui,Avenir,Helvetica,Arial,sans-serif;line-height:1.5;font-weight:400;color-scheme:light dark;color:#ffffffde;background-color:#242424;font-synthesis:none;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}a{font-weight:500;color:#646cff;text-decoration:inherit}a:hover{color:#535bf2}body{margin:0;display:flex;place-items:center;min-width:320px;min-height:100vh}h1{font-size:3.2em;line-height:1.1}button{border-radius:8px;border:1px solid transparent;padding:.6em 1.2em;font-size:1em;font-weight:500;font-family:inherit;background-color:#1a1a1a;cursor:pointer;transition:border-color .25s}button:hover{border-color:#646cff}button:focus,button:focus-visible{outline:4px auto -webkit-focus-ring-color}.card{padding:2em}#app{max-width:1280px;margin:0 auto;padding:2rem;text-align:center}@media (prefers-color-scheme: light){:root{color:#213547;background-color:#fff}a:hover{color:#747bff}button{background-color:#f9f9f9}}", Ce = (e, c) => {
  const s = e.__vccOpts || e;
  for (const [o, i] of c)
    s[o] = i;
  return s;
}, $e = /* @__PURE__ */ Ce(we, [["styles", [ke]]]);
function Le() {
  const e = Ne($e);
  customElements.define("vuejs-example", e);
}
export {
  Le as declareVuejsExample
};
